//DArray.h
#ifndef DARRAY
#define DARRAY

template <class T> class DArray {
        int array_size;
        T* array;
public:
        DArray();
        DArray(int aSize);
        DArray(const DArray<T>& Source);
        ~DArray();
        bool IsValid(int index);
        T& operator [](int index);
        void Resize(const int nSize);
        int GetSize() { return array_size;}
};
//---------------------------------------------------------------------------
template <class T> DArray<T>::DArray() {
        array_size = 1;
        array = new T[array_size];
        if (!array)
                throw "    .";
}

template <class T> DArray<T>::DArray(int aSize) {
        if (aSize < 1)
                throw "  .";
        array_size = aSize;
        array = new T[array_size];
        if (!array)
                throw "    .";
}

template <class T> DArray<T>::DArray(const DArray<T>& Source) {
        array_size = Source.array_size;
        array = new T[array_size];
        if (!array)
                throw "    .";
        int n = array_size;
        while (n--)
                array[n] = Source.array[n];
}

template <class T> DArray<T>::~DArray() {
        if (array) {
                delete [] array;
                array = NULL;
                array_size = 0;
        }
}

template <class T> T& DArray<T>::operator [] (int index) {
        if (!IsValid(index))
       	        throw "    .";

        return array[index];
}

template <class T> bool DArray<T>::IsValid (int index) {
        return (index >= 0 && index < array_size)?true:false;
}

template <class T> void DArray<T>::Resize(int nSize) {
        if (nSize <= 0)
                throw "  ";
        if (nSize == array_size)
                return;
        if (array)
        {
                T* new_array = new T[nSize];
                if (!new_array)
                        throw "    -   .";

                int n = (nSize < array_size)?nSize:array_size;
                CopyMemory(new_array, array, sizeof(T) * n);
                delete [] array;
                array = new_array;
                array_size = nSize;
        }
};

#endif  //DARRAY

