//list.h
#ifndef LIST_H
#define LIST_H

/******************************************************************************/

template <class T> struct list_element {
	T data;
	int index;
	list_element *next;
        list_element *prev;
};

template <class T> class list {
protected:
	list_element<T> *head_of_list;
	list_element<T> *tail_of_list;
	list_element<T> list_data;
        virtual list_element<T>* Ins(T TData, int id);
public:
	list();
        ~list();
        bool Clear_List();
	virtual bool Insert(T TData, int id) = 0;
	bool Delete(int id);
	//  
	list_element<T>* Head() { return head_of_list; }
	//  
	list_element<T>* Tail() { return tail_of_list; }
	list_element<T>* operator [](int id);
	//   
	bool IsEmpty() { return !head_of_list; }
	bool IsValid(int id);
        T (*ForEach_Func)(T element);
        void ForEach();
};

template <class T> class list_one : public list<T> {
public:
        bool Insert(T TData, int id);
};

template <class T> class list_two : public list<T> {
public:
        bool Insert(T TData, int id);
};

template <class T> class list_round : public list<T> {
public:
        bool Insert(T TData, int id);
};

/******************************************************************************/

template <class T> list<T>::list() {
	head_of_list = tail_of_list = NULL;
	list_data.data = T();
	list_data.index = -1;
        ForEach_Func = NULL;
}

template <class T> list<T>::~list() {
        Clear_List();
}

template <class T> bool list<T>::Clear_List() {
        list_element<T> *p1, *p2;

        if (head_of_list)
        {
                p2 = head_of_list;
                do
	        {
                        p1 = p2;
                        p2 = p2->next;
                        if (p1 == p2)
                                p2 = NULL;
                        delete p1;
        	}
                while (p2 != tail_of_list && p2 != NULL);
                if (p2)
                        delete p2;
        }
        head_of_list = NULL;
        tail_of_list = NULL;
        return true;
}

// ,      
template <class T> list_element<T>* list<T>::operator[](int id) {
	list_element<T> *p;

	if (!IsValid(id))
	        throw "     .";

	p = head_of_list;
	do
	{
		if (id == p->index)
			return p;
		p = p->next;
	}
	while (p != tail_of_list);
        return p;
}

//  ,       
template <class T> bool list<T>::IsValid(int id) {
	list_element<T> *p;

	p = head_of_list;
        if (!p)
		return false;
	do
	{
		if (id == p->index)
			return true;
		p = p->next;
	}
        while (p != tail_of_list->next);
	return false;
}

template <class T> void list<T>::ForEach() {
        list_element<int>* p;

        if (!ForEach_Func)
                throw " ForEach_Func  .";

        p = head_of_list;
        if (!p)
		throw " .";

	do
	{
		p->data = ForEach_Func(p->data);
		p = p->next;
	}
        while (p != tail_of_list->next);
}

template <class T> list_element<T>* list<T>::Ins(T TData, int id) {
        list_element<T> *p;

        if (IsValid(id)) {
                (*this)[id]->data = TData;
                return NULL;
        }

	p = new list_element<T>;
	if (!p)
		throw "  .    .";

	p->data = TData;
	p->index = id;

        if (head_of_list)
		tail_of_list->next = p;
	else {
	        head_of_list = p;
                head_of_list->prev = NULL;
        }
        return p;
}

template <class T> bool list<T>::Delete(int id) {
        list_element<T> *p1, *p2;

	if ( IsEmpty() )
		throw " .";
	p1 = (*this)[id];

        if (p1 == head_of_list && p1 == tail_of_list)
        {
		head_of_list = NULL;
                tail_of_list = NULL;
                delete p1;
                return false;
        }
	p2 = head_of_list;
        if (p1 != p2)
	        while (p2->next != p1)
		        p2 = p2->next;
	if (p1 == head_of_list)
		head_of_list = head_of_list->next;
        else
		if (p1 == tail_of_list)
		{
			tail_of_list = p2;
			tail_of_list->next = NULL;
		}
		else
                {
			p2->next = p1->next;
                        p1->next->prev = p1->prev;
                }
	delete p1;
	return true;
}

/******************************************************************************/

//    
template <class T> bool list_one<T>::Insert(T TData, int id) {
	list_element<T> *p;

        p = Ins(TData, id);
        if (NULL == p)
                return true;

	p->prev = NULL;
	tail_of_list = p;
      	p->next = NULL;
	return true;
}

/******************************************************************************/

//    
template <class T> bool list_two<T>::Insert(T TData, int id) {
	list_element<T> *p;

        p = Ins(TData, id);
        if (NULL == p)
                return true;

        p->prev = tail_of_list;
	tail_of_list = p;
      	p->next = NULL;
	return true;
}

/******************************************************************************/

//    
template <class T> bool list_round<T>::Insert(T TData, int id) {
	list_element<T> *p;

        p = Ins(TData, id);
        if (NULL == p)
                return true;

        p->prev = NULL;
	tail_of_list = p;
        p->next = head_of_list;

	return true;
}

#endif /* LIST_H */
