//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Queue_Example.h"
#include "Benchmark.h"
#include "queue.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

queue_list<int> *queue_int;
queue_list<float> *queue_float;

queue_array<int> *queue_int_a;
queue_array<float> *queue_float_a;

enum {i, f} data_type;
enum {l, a} queue_type;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
        Int_RadioButton->Checked = True;
        Elements_Table->DefaultColWidth = 75;
        Elements_Table->DefaultRowHeight = 20;
        Elements_Table->Width = 155;
        Elements_Table->ColCount = 2;
        Elements_Table->RowCount = 1;
        Elements_Table->FixedCols = 0;
        Elements_Table->FixedRows = 0;

        queue_int = new queue_list<int>;
        queue_float = new queue_list<float>;
        queue_int_a = new queue_array<int>;
        queue_float_a = new queue_array<float>;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Float_RadioButtonClick(TObject *Sender)
{
        Elements_Table->RowCount = 1;
        Elements_Table->Cells[0][0] = ' ';
        Elements_Table->Cells[1][0] = ' ';
        data_type = f;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Int_RadioButtonClick(TObject *Sender)
{
        Elements_Table->RowCount = 1;
        Elements_Table->Cells[0][0] = ' ';
        Elements_Table->Cells[1][0] = ' ';
        data_type = i;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
        delete queue_int;
        delete queue_float;
        delete queue_int_a;
        delete queue_float_a;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Insert_ButtonClick(TObject *Sender)
{
        try {
                switch (queue_type) {
                        case l: switch (data_type) {
                                        case i:
                                                queue_int->Insert(StrToInt(Element->Text), StrToInt(Priority_Element->Text));
                                                Elements_Table->Cells[0][Elements_Table->RowCount-1] = Element->Text + " | " + Priority_Element->Text;
                                                break;
                                        case f:
                                                queue_float->Insert(StrToFloat(Element->Text), StrToInt(Priority_Element->Text));
                                                Elements_Table->Cells[0][Elements_Table->RowCount-1] = Element->Text + " | " + Priority_Element->Text;
                                                break;
                        }
                        break;
                        case a: switch (data_type) {
                                        case i:
                                                queue_int_a->Insert(StrToInt(Element->Text), StrToInt(Priority_Element->Text));
                                                Elements_Table->Cells[0][Elements_Table->RowCount-1] = Element->Text + " | " + Priority_Element->Text;
                                                break;
                                        case f:
                                                queue_float_a->Insert(StrToFloat(Element->Text), StrToInt(Priority_Element->Text));
                                                Elements_Table->Cells[0][Elements_Table->RowCount-1] = Element->Text + " | " + Priority_Element->Text;
                                                break;
                        }
                        break;
                }
        }
        catch (char* msg) {
                Application->MessageBoxA(msg, ":", MB_OK);
        }
        Elements_Table->RowCount++;
        Elements_Table->Cells[0][Elements_Table->RowCount-1] = ' ';
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Pop_ButtonClick(TObject *Sender)
{
        Elements_Table->Cells[0][Elements_Table->RowCount-1] = ' ';

        try {
                switch (queue_type) {
                        case l: switch (data_type) {
                                        case i:
                                                Elements_Table->Cells[1][0] = IntToStr(queue_int->Pop());
                                                break;
                                        case f:
                                                Elements_Table->Cells[1][0] = FloatToStr(queue_float->Pop());
                                                break;
                        }
                        break;
                        case a: switch (data_type) {
                                        case i:
                                                Elements_Table->Cells[1][0] = IntToStr(queue_int_a->Pop());
                                                break;
                                        case f:
                                                Elements_Table->Cells[1][0] = FloatToStr(queue_float_a->Pop());
                                                break;
                        }
                        break;
                }
        }
        catch (char* msg) {
                Application->MessageBoxA(msg, ":", MB_OK);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Size_ButtonClick(TObject *Sender)
{
        try {
                switch (queue_type) {
                        case l: switch (data_type) {
                                        case i:
                                                Size_Edit->Text = IntToStr(queue_int->GetSize());
                                                break;
                                        case f:
                                                Size_Edit->Text = IntToStr(queue_float->GetSize());
                                                break;
                        }
                        break;
                        case a:
                                if (StrToInt(Size_Edit->Text) < Elements_Table->RowCount)
                                        Elements_Table->RowCount = StrToInt(Size_Edit->Text) + 1;
                                Elements_Table->Cells[0][Elements_Table->RowCount-1] = ' ';
                                switch (data_type) {
                                        case i:
                                                queue_int_a->Resize(StrToInt(Size_Edit->Text));
                                                break;
                                        case f:
                                                queue_float_a->Resize(StrToInt(Size_Edit->Text));
                                                break;
                        }
                        break;
                }
        }
        catch (char* msg) {
                Application->MessageBoxA(msg, ":", MB_OK);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Clear_ButtonClick(TObject *Sender)
{
        try {
                switch (queue_type) {
                        case l:
                                Elements_Table->RowCount = 1;
                                Elements_Table->Cells[0][0] = ' ';
                                Elements_Table->Cells[1][0] = ' ';
                                switch (data_type) {
                                        case i:
                                                queue_int->Clear();
                                                break;
                                        case f:
                                                queue_float->Clear();
                                                break;
                        }
                        break;
                        case a: switch (data_type) {
                                        case i:
                                                Size_Edit->Text = IntToStr(queue_int_a->GetSize());
                                                break;
                                        case f:
                                                Size_Edit->Text = IntToStr(queue_float_a->GetSize());
                                                break;
                        }
                }
        }
        catch (char* msg) {
                Application->MessageBoxA(msg, ":", MB_OK);
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Type_StackChange(TObject *Sender)
{
        if (Type_Stack->Text == "  ") {
                queue_type = l;
                Clear_Button->Caption = "";
                Size_Button->Caption = "";
        }
        else {
                queue_type = a;
                Clear_Button->Caption = "";
                Size_Button->Caption = " :";
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Benchmark_ButtonClick(TObject *Sender)
{
        Form2->ShowModal();
}
//---------------------------------------------------------------------------


