//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Stack_Example.h"
#include "Benchmark.h"
#include "stack.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

stack_list<int> *stack_int;
stack_list<float> *stack_float;

stack_array<int> *stack_int_a;
stack_array<float> *stack_float_a;

enum {i, f} data_type;
enum {l, a} stack_type;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
        Int_RadioButton->Checked = True;
        Elements_Table->DefaultColWidth = 75;
        Elements_Table->DefaultRowHeight = 20;
        Elements_Table->Width = 155;
        Elements_Table->ColCount = 2;
        Elements_Table->RowCount = 1;
        Elements_Table->FixedCols = 0;
        Elements_Table->FixedRows = 0;

        stack_int = new stack_list<int>;
        stack_float = new stack_list<float>;
        stack_int_a = new stack_array<int>;
        stack_float_a = new stack_array<float>;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Float_RadioButtonClick(TObject *Sender)
{
        Elements_Table->RowCount = 1;
        Elements_Table->Cells[0][0] = ' ';
        Elements_Table->Cells[1][0] = ' ';
        data_type = f;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Int_RadioButtonClick(TObject *Sender)
{
        Elements_Table->RowCount = 1;
        Elements_Table->Cells[0][0] = ' ';
        Elements_Table->Cells[1][0] = ' ';
        data_type = i;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
        delete stack_int;
        delete stack_float;
        delete stack_int_a;
        delete stack_float_a;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Push_ButtonClick(TObject *Sender)
{
        try {
                switch (stack_type) {
                        case l: switch (data_type) {
                                        case i:
                                                stack_int->Push(StrToInt(Element->Text));
                                                Elements_Table->Cells[0][Elements_Table->RowCount-1] = IntToStr(stack_int->Top());
                                                break;
                                        case f:
                                                stack_float->Push(StrToFloat(Element->Text));
                                                Elements_Table->Cells[0][Elements_Table->RowCount-1] = FloatToStr(stack_float->Top());
                                                break;
                        }
                        break;
                        case a: switch (data_type) {
                                        case i:
                                                stack_int_a->Push(StrToInt(Element->Text));
                                                Elements_Table->Cells[0][Elements_Table->RowCount-1] = IntToStr(stack_int_a->Top());
                                                break;
                                        case f:
                                                stack_float_a->Push(StrToFloat(Element->Text));
                                                Elements_Table->Cells[0][Elements_Table->RowCount-1] = FloatToStr(stack_float_a->Top());
                                                break;
                        }
                        break;
                }
        }
        catch (char* msg) {
                Application->MessageBoxA(msg, ":", MB_OK);
        }
        Elements_Table->RowCount++;
        Elements_Table->Cells[0][Elements_Table->RowCount-1] = ' ';
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Pop_ButtonClick(TObject *Sender)
{
        Elements_Table->RowCount--;
        Elements_Table->Cells[0][Elements_Table->RowCount-1] = ' ';

        try {
                switch (stack_type) {
                        case l: switch (data_type) {
                                        case i:
                                                Elements_Table->Cells[1][0] = IntToStr(stack_int->Pop());
                                                break;
                                        case f:
                                                Elements_Table->Cells[1][0] = FloatToStr(stack_float->Pop());
                                                break;
                        }
                        break;
                        case a: switch (data_type) {
                                        case i:
                                                Elements_Table->Cells[1][0] = IntToStr(stack_int_a->Pop());
                                                break;
                                        case f:
                                                Elements_Table->Cells[1][0] = FloatToStr(stack_float_a->Pop());
                                                break;
                        }
                        break;
                }
        }
        catch (char* msg) {
                Application->MessageBoxA(msg, ":", MB_OK);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Size_ButtonClick(TObject *Sender)
{
        try {
                switch (stack_type) {
                        case l: switch (data_type) {
                                        case i:
                                                Size_Edit->Text = IntToStr(stack_int->GetSize());
                                                break;
                                        case f:
                                                Size_Edit->Text = IntToStr(stack_float->GetSize());
                                                break;
                        }
                        break;
                        case a:
                                if (StrToInt(Size_Edit->Text) < Elements_Table->RowCount)
                                        Elements_Table->RowCount = StrToInt(Size_Edit->Text) + 1;
                                Elements_Table->Cells[0][Elements_Table->RowCount-1] = ' ';
                                switch (data_type) {
                                        case i:
                                                stack_int_a->Resize(StrToInt(Size_Edit->Text));
                                                break;
                                        case f:
                                                stack_float_a->Resize(StrToInt(Size_Edit->Text));
                                                break;
                        }
                        break;
                }
        }
        catch (char* msg) {
                Application->MessageBoxA(msg, ":", MB_OK);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Clear_ButtonClick(TObject *Sender)
{
        try {
                switch (stack_type) {
                        case l:
                                Elements_Table->RowCount = 1;
                                Elements_Table->Cells[0][0] = ' ';
                                Elements_Table->Cells[1][0] = ' ';
                                switch (data_type) {
                                        case i:
                                                stack_int->Clear();
                                                break;
                                        case f:
                                                stack_float->Clear();
                                                break;
                        }
                        break;
                        case a: switch (data_type) {
                                        case i:
                                                Size_Edit->Text = IntToStr(stack_int_a->GetSize());
                                                break;
                                        case f:
                                                Size_Edit->Text = IntToStr(stack_float_a->GetSize());
                                                break;
                        }
                }
        }
        catch (char* msg) {
                Application->MessageBoxA(msg, ":", MB_OK);
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Type_StackChange(TObject *Sender)
{
        if (Type_Stack->Text == "  ") {
                stack_type = l;
                Clear_Button->Caption = "";
                Size_Button->Caption = "";
        }
        else {
                stack_type = a;
                Clear_Button->Caption = "";
                Size_Button->Caption = " :";
        }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Benchmark_ButtonClick(TObject *Sender)
{
        Form2->ShowModal();        
}
//---------------------------------------------------------------------------

